%define ALD_Ver		1.2.4

Name:         groff

#WARNING !!! use gcc 4.4.7 and static libstdc++.a !!!!!!!!!!!!!!!!!!!!!!

License:      GPL
Summary:      GNU min groff document formatting system for displaying man-pages.
Group:        Applications/Text
Version:      1.17.2
Release:      2

Source: %{name}-%{version}.tar.xz
Source1: CROSS.sh

%define DestDir		/ps_pdf_printer
# -----------------------------------------------------
%if %{_target_cpu} == %{_build_cpu}
%define _CROSS 0
%else
# rpm --target=x86_64 -ba xxxxx.spec
%define _CROSS 1
%endif

%define TO_ARCH %{_target_cpu}

%if %{_target_cpu} == "armv6l"
%define ARM_ARCH armv6zk
%define ARM_FPU  -mfpu=vfp -mfloat-abi=hard
%define TO_ARCH %{ARM_ARCH}
%endif

%if %{_target_cpu} == "armv7l"
%define ARM_ARCH armv7-a
%define ARM_FPU  -mfpu=vfpv3-d16 -mfloat-abi=hard
%define TO_ARCH %{ARM_ARCH}
%endif

%define BUILD_TAR 1
#------------------ CROSS DIR --------------------
%if %{_CROSS}

%if %{_os} == "mingw"
%define target %{_arch}-%{_vendor}-%{_os}%{__isa_bits}
%else  #win32 || win64
%define target %{_arch}-%{_os}%{_gnu}
%endif
%define target_  %{target}-

%define crossdir	/cross
%if %{_arch} == "arm"
%define csysdir		%{crossdir}/%{ARM_ARCH}
%else
%define csysdir		%{crossdir}/%{_target_cpu}
%endif
%define csysbindir	%{csysdir}/bin

%define __os_install_post %{nil}

%define CrossDestDir	/Cross

%define _srcrpmdir %{_topdir}/SRPMS/tmp

%else  #_CROSS

%define csysdir		%{nil}
%define csysbindir	/usr/bin
%define CrossDestDir	%{nil}
%define _srcrpmdir %{_topdir}/SRPMS/%{ALD_Ver}

%define target %{_arch}-%{_os}%{_gnu}
%define target_  %{nil}

%endif # !_CROSS || !TARGETBUILD_CROSS

%define docdir %{_defaultdocdir}/%{name}

# ------------------- description ------------------------------------
%description
The groff package provides compatible versions of troff, nroff, eqn,
tbl, and other Unix text-formatting utilities.
# --------------------------------------
%package rest
Summary:      GNU all tools for groff document formatting system.
Group:        Applications/Text
%description rest
The groff package provides compatible versions of troff, nroff, eqn,
tbl, and other Unix text-formatting utilities.

# ------------------- setup ------------------------------------------
%Prep
%setup -q -n %{name}-%{version}

sed -i s:"enum {":"enum E {": src/preproc/grn/main.cc

# ------------------- Build ------------------------------------------
%Build
%if %{_CROSS}
PATH=%{csysbindir}:$PATH:/opt/perl/bin
GCC_NoHostPath=d
export PATH GCC_NoHostPath
%else
export PATH=$PATH:/opt/perl/bin
%endif

GCC_VER_STR=`%{target_}gcc -dumpversion`

%if %{_arch} == "i386"
OPTFLAGS="-Os -march=i486 -mpreferred-stack-boundary=2 -falign-functions=1 -falign-jumps=1 -falign-loops=1 -fomit-frame-pointer"
OPT47=`case $GCC_VER_STR in 4.[789].*) echo "-fno-asynchronous-unwind-tables" ;; esac`
%endif
%if %{_arch} == "x86_64"
OPTFLAGS="-Os"
OPT47=`case $GCC_VER_STR in 4.[789].*) echo "-fno-asynchronous-unwind-tables" ;; esac`
%endif
%if %{_arch} == "arm"
OPTFLAGS="-Os -march=%{ARM_ARCH} %{ARM_FPU} -munaligned-access"
OPT47=
%endif

CFLAGS="$OPTFLAGS $OPT47 -ffunction-sections -fdata-sections -std=gnu99"

CXXFLAGS="$OPTFLAGS $OPT47 -ffunction-sections -fdata-sections -fno-exceptions -ffriend-injection"
LDFLAGS="-Wl,--gc-sections -static-libgcc -static-libstdc++"
CC=%{target_}gcc
CXX=%{target_}g++

%configure \
	--build=%{_build} \
%if %{_CROSS}
	--host=%{target} \
%endif
	&>FConfigure_log.txt

make &>FMake_log.txt

# ------------------- Install ----------------------------------------
%Install
%if %{_CROSS}
PATH=%{csysbindir}:$PATH:/opt/perl/bin
GCC_NoHostPath=d
export PATH GCC_NoHostPath
%else
export PATH=$PATH:/opt/perl/bin
%endif

rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT
mkdir -p %{_srcrpmdir}
mkdir -p $RPM_BUILD_ROOT%{docdir}

%makeinstall &>FInstall_log.txt

pushd $RPM_BUILD_ROOT%{_bindir}
ln -s tbl gtbl
popd

cp -p FDL README VERSION $RPM_BUILD_ROOT%{docdir}/
ln -s /usr/share/doc/gpl-2.0.txt $RPM_BUILD_ROOT%{docdir}/COPYING

%if %{_CROSS}
TARGET_PRFIX=%{_prefix}
TARGET_CROSS_PRFIX=%{csysdir}
TARGET_NAME=%{target}
MKCROSSDIR=0
export TARGET_PRFIX TARGET_CROSS_PRFIX TARGET_NAME MKCROSSDIR
%SOURCE1
%endif #_CROSS

%if !%{_CROSS}
if test -f /opt/aldccp/bin/packages_idx; then
  /opt/aldccp/bin/packages_idx -p %{name} -v %{version} -r %{DestDir} $RPM_BUILD_ROOT
fi
%endif

# ------------------- Clean ------------------------------------------
%Clean
DE=%{version}-%{release}.%{TO_ARCH}.rpm
DD=%{_rpmdir}/%{TO_ARCH}/%{ALD_Ver}%{DestDir}

pushd %{_rpmdir}/%{_target_cpu}
  SE=%{version}-%{release}.%{_target_cpu}.rpm
  mkdir -p $DD
  mv %{name}-$SE $DD/%{name}-$DE
  mv %{name}-rest-$SE $DD/%{name}-rest-$DE
popd

# --------------- build *.tgz ------------------------
%if %{BUILD_TAR}
pushd $RPM_BUILD_ROOT
  TMP_TO=$DD/tar
  mkdir -p $TMP_TO
  tmp=%{name}-%{version}-%{release}.%{TO_ARCH}
  mkdir -p $tmp
  cp -r usr $tmp/
  tar -cjf $tmp.tar.bz2 $tmp
  mv $tmp.tar.bz2 $TMP_TO
  rm -r $tmp
popd
%endif  #BUILD_TAR

# ------------------- Files ------------------------------------------
%Files
%{_bindir}/eqn
%{_bindir}/groff
%{_bindir}/grotty
%{_bindir}/gtbl
%{_bindir}/nroff
%{_bindir}/tbl
%{_bindir}/troff
%{_datadir}/groff/site-tmac
%{_datadir}/groff/1.17.2/eign
%{_datadir}/groff/1.17.2/font/devascii
%{_datadir}/groff/1.17.2/font/devlatin1
%{_datadir}/groff/1.17.2/font/devutf8

%{_datadir}/groff/1.17.2/tmac/mdoc
%{_datadir}/groff/1.17.2/tmac/an-old.tmac
%{_datadir}/groff/1.17.2/tmac/an.tmac
%{_datadir}/groff/1.17.2/tmac/andoc.tmac
%{_datadir}/groff/1.17.2/tmac/doc.tmac
%{_datadir}/groff/1.17.2/tmac/latin1.tmac
%{_datadir}/groff/1.17.2/tmac/tty-char.tmac
%{_mandir}/man1/eqn.1.gz
%{_mandir}/man1/groff.1.gz
%{_mandir}/man1/grotty.1.gz
%{_mandir}/man1/nroff.1.gz
%{_mandir}/man1/tbl.1.gz
%{_mandir}/man1/troff.1.gz
%{docdir}

%Files rest
%{_bindir}/addftinfo
%{_bindir}/afmtodit
%{_bindir}/grn
%{_bindir}/grodvi
%{_bindir}/grog
%{_bindir}/grolbp
%{_bindir}/grolj4
%{_bindir}/grops
%{_bindir}/hpftodit
%{_bindir}/indxbib
%{_bindir}/lkbib
%{_bindir}/lookbib
%{_bindir}/mmroff
%{_bindir}/neqn
%{_bindir}/pfbtops
%{_bindir}/pic
%{_bindir}/post-grohtml
%{_bindir}/pre-grohtml
%{_bindir}/refer
%{_bindir}/soelim
%{_bindir}/tfmtodit
%{_libdir}
%{_datadir}/groff/1.17.2/font/devX100
%{_datadir}/groff/1.17.2/font/devX100-12
%{_datadir}/groff/1.17.2/font/devX75
%{_datadir}/groff/1.17.2/font/devX75-12
%{_datadir}/groff/1.17.2/font/devdvi
%{_datadir}/groff/1.17.2/font/devhtml
%{_datadir}/groff/1.17.2/font/devlbp
%{_datadir}/groff/1.17.2/font/devlj4
%{_datadir}/groff/1.17.2/font/devps

%{_datadir}/groff/1.17.2/tmac/mm
%{_datadir}/groff/1.17.2/tmac/X.tmac
%{_datadir}/groff/1.17.2/tmac/Xps.tmac
%{_datadir}/groff/1.17.2/tmac/a4.tmac
%{_datadir}/groff/1.17.2/tmac/doc-old.tmac
%{_datadir}/groff/1.17.2/tmac/dvi.tmac
%{_datadir}/groff/1.17.2/tmac/e.tmac
%{_datadir}/groff/1.17.2/tmac/eqnrc
%{_datadir}/groff/1.17.2/tmac/html.tmac
%{_datadir}/groff/1.17.2/tmac/hyphen.us
%{_datadir}/groff/1.17.2/tmac/lj4.tmac
%{_datadir}/groff/1.17.2/tmac/m.tmac
%{_datadir}/groff/1.17.2/tmac/man.tmac
%{_datadir}/groff/1.17.2/tmac/mandoc.tmac
%{_datadir}/groff/1.17.2/tmac/mdoc.tmac
%{_datadir}/groff/1.17.2/tmac/me.tmac
%{_datadir}/groff/1.17.2/tmac/ms.tmac
%{_datadir}/groff/1.17.2/tmac/mse.tmac
%{_datadir}/groff/1.17.2/tmac/mwww.tmac
%{_datadir}/groff/1.17.2/tmac/pic.tmac
%{_datadir}/groff/1.17.2/tmac/ps.tmac
%{_datadir}/groff/1.17.2/tmac/psatk.tmac
%{_datadir}/groff/1.17.2/tmac/psold.tmac
%{_datadir}/groff/1.17.2/tmac/pspic.tmac
%{_datadir}/groff/1.17.2/tmac/s.tmac
%{_datadir}/groff/1.17.2/tmac/safer.tmac
%{_datadir}/groff/1.17.2/tmac/trace.tmac
%{_datadir}/groff/1.17.2/tmac/troffrc
%{_datadir}/groff/1.17.2/tmac/troffrc-end
%{_datadir}/groff/1.17.2/tmac/tty.tmac
%{_datadir}/groff/1.17.2/tmac/www.tmac
%{_mandir}/man1/addftinfo.1.gz
%{_mandir}/man1/afmtodit.1.gz
%{_mandir}/man1/grn.1.gz
%{_mandir}/man1/grodvi.1.gz
%{_mandir}/man1/grog.1.gz
%{_mandir}/man1/grohtml.1.gz
%{_mandir}/man1/grolbp.1.gz
%{_mandir}/man1/grolj4.1.gz
%{_mandir}/man1/grops.1.gz
%{_mandir}/man1/hpftodit.1.gz
%{_mandir}/man1/indxbib.1.gz
%{_mandir}/man1/lkbib.1.gz
%{_mandir}/man1/lookbib.1.gz
%{_mandir}/man1/neqn.1.gz
%{_mandir}/man1/pfbtops.1.gz
%{_mandir}/man1/pic.1.gz
%{_mandir}/man1/refer.1.gz
%{_mandir}/man1/soelim.1.gz
%{_mandir}/man1/tfmtodit.1.gz
%{_mandir}/man5
%{_mandir}/man7
